// ezManagerLib_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ezManagerLib_Example.h"
#include "ezManagerLib_ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzManagerLib_ExampleDlg dialog

CEzManagerLib_ExampleDlg::CEzManagerLib_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEzManagerLib_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEzManagerLib_ExampleDlg)
	m_local_remote = 0;
	m_product = _T("");
	m_status = _T("");
	m_baud_rate1 = _T("");
	m_baud_rate2 = _T("");
	m_baud_rate3 = _T("");
	m_baud_rate4 = _T("");
	m_peer1		 = _T("");
	m_peer2		 = _T("");
	m_peer3		 = _T("");
	m_peer4		 = _T("");
	m_macro = FALSE;
	m_modbus = FALSE;
	m_http = FALSE;
	m_input_addr = 0;
	m_output_addr = 0;
	m_script_0 = _T("");
	m_slave_id = 0;
	m_cur_pwd = _T("");
	m_new_pwd = _T("");
	m_di_str0 = _T("");
	m_di_str1 = _T("");
	m_di_str2 = _T("");
	m_di_str3 = _T("");
	m_di_str4 = _T("");
	m_di_str5 = _T("");
	m_di_str6 = _T("");
	m_di_str7 = _T("");
	m_do_str0 = _T("");
	m_do_str1 = _T("");
	m_do_str2 = _T("");
	m_do_str3 = _T("");
	m_do_str4 = _T("");
	m_do_str5 = _T("");
	m_do_str6 = _T("");
	m_do_str7 = _T("");
	m_ddns_hostname = _T("");
	m_ddns_id = _T("");
	m_ddns_interval = 0;
	m_ddns_port = 0;
	m_ddns_pwd = _T("");
	m_fw_version = _T("");
	m_ea0 = _T("00");
	m_ea1 = _T("30");
	m_ea2 = _T("f9");
	m_ea3 = _T("00");
	m_ea4 = _T("00");
	m_ea5 = _T("01");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	this->lib_env_base = (struct lib_env*)malloc(sizeof(struct lib_env)*256);

	p_baud[0] = &m_baud_rate1;
	p_baud[1] = &m_baud_rate2;
	p_baud[2] = &m_baud_rate3;
	p_baud[3] = &m_baud_rate4;

	p_baud_ctrl[0] = &m_baud_ctrl1;
	p_baud_ctrl[1] = &m_baud_ctrl2;
	p_baud_ctrl[2] = &m_baud_ctrl3;
	p_baud_ctrl[3] = &m_baud_ctrl4;

	p_mux_ctrl[0] = &m_mux1;
	p_mux_ctrl[1] = &m_mux2;
	p_mux_ctrl[2] = &m_mux3;
	p_mux_ctrl[3] = &m_mux4;

	p_peer[0] = &m_peer1;
	p_peer[1] = &m_peer2;
	p_peer[2] = &m_peer3;
	p_peer[3] = &m_peer4;

	p_peer_ctrl[0] = &m_peer_ctrl1;
	p_peer_ctrl[1] = &m_peer_ctrl2;
	p_peer_ctrl[2] = &m_peer_ctrl3;
	p_peer_ctrl[3] = &m_peer_ctrl4;
}
CEzManagerLib_ExampleDlg::~CEzManagerLib_ExampleDlg()
{
	Exit_Library();
	free(this->lib_env_base);
}

void CEzManagerLib_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEzManagerLib_ExampleDlg)
	DDX_Control(pDX, IDC_COMBO_TCP_CONNECTION, m_tcp_connection);
	DDX_Control(pDX, IDC_COMBO_DDNS_STYLE, m_combo_style_ctrl);
	DDX_Control(pDX, IDC_COMBO_DDNS, m_combo_ddns_ctrl);
	DDX_Control(pDX, IDC_SUBNET, m_subnet);
	DDX_Control(pDX, IDC_EDIT_SLAVE_ID, m_slave_id_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_0, m_script_0_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_1, m_script_1_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_2, m_script_2_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_3, m_script_3_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_4, m_script_4_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_5, m_script_5_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_6, m_script_6_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_7, m_script_7_ctrl);
	DDX_Control(pDX, IDC_EDIT_OUTPUT_ADDR, m_output_addr_ctrl);
	DDX_Control(pDX, IDC_EDIT_INPUT_ADDR, m_input_addr_ctrl);
	DDX_Control(pDX, IDC_CHECK_MODBUS, m_modbus_ctrl);
	DDX_Control(pDX, IDC_CHECK_MACRO, m_macro_ctrl);
	DDX_Control(pDX, IDC_CHECK_HTTP, m_http_ctrl);
	DDX_Control(pDX, IDC_LOCAL_IP, m_local_ip);
	DDX_Control(pDX, IDC_EDIT_PEER, m_peer_ctrl1);
	DDX_Control(pDX, IDC_EDIT_PEER2, m_peer_ctrl2);
	DDX_Control(pDX, IDC_EDIT_PEER3, m_peer_ctrl3);
	DDX_Control(pDX, IDC_EDIT_PEER4, m_peer_ctrl4);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE, m_baud_ctrl1);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE2, m_baud_ctrl2);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE3, m_baud_ctrl3);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE4, m_baud_ctrl4);
	DDX_Control(pDX, IDC_COMBO_MUX, m_mux1);
	DDX_Control(pDX, IDC_COMBO_MUX2, m_mux2);
	DDX_Control(pDX, IDC_COMBO_MUX3, m_mux3);
	DDX_Control(pDX, IDC_COMBO_MUX4, m_mux4);
	DDX_Control(pDX, IDC_EDIT_STATUS, m_status_ctrl);
	DDX_Control(pDX, IDC_LIST_EZTCP, m_list_eztcp);
	DDX_Control(pDX, IDC_REMOTE_IP, m_remote_ip);
	DDX_Radio(pDX, IDC_RADIO_LOCAL, m_local_remote);
	DDX_Text(pDX, IDC_EDIT_PRODUCT, m_product);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_status);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE, m_baud_rate1);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE2, m_baud_rate2);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE3, m_baud_rate3);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE4, m_baud_rate4);
	DDX_Text(pDX, IDC_EDIT_PEER, m_peer1);
	DDX_Text(pDX, IDC_EDIT_PEER2, m_peer2);
	DDX_Text(pDX, IDC_EDIT_PEER3, m_peer3);
	DDX_Text(pDX, IDC_EDIT_PEER4, m_peer4);
	DDX_Check(pDX, IDC_CHECK_MACRO, m_macro);
	DDX_Check(pDX, IDC_CHECK_MODBUS, m_modbus);
	DDX_Check(pDX, IDC_CHECK_HTTP, m_http);
	DDX_Text(pDX, IDC_EDIT_INPUT_ADDR, m_input_addr);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_ADDR, m_output_addr);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_0, m_script_0);
	DDV_MaxChars(pDX, m_script_0, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_1, m_script_1);
	DDV_MaxChars(pDX, m_script_1, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_2, m_script_2);
	DDV_MaxChars(pDX, m_script_2, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_3, m_script_3);
	DDV_MaxChars(pDX, m_script_3, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_4, m_script_4);
	DDV_MaxChars(pDX, m_script_4, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_5, m_script_5);
	DDV_MaxChars(pDX, m_script_5, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_6, m_script_6);
	DDV_MaxChars(pDX, m_script_6, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_7, m_script_7);
	DDV_MaxChars(pDX, m_script_7, 32);
	DDX_Text(pDX, IDC_EDIT_SLAVE_ID, m_slave_id);
	DDX_Text(pDX, IDC_EDIT_CUR_PWD, m_cur_pwd);
	DDV_MaxChars(pDX, m_cur_pwd, 8);
	DDX_Text(pDX, IDC_EDIT_NEW_PWD, m_new_pwd);
	DDV_MaxChars(pDX, m_new_pwd, 8);
	DDX_Control(pDX, IDC_EDIT_DI_STR0, m_di_str0_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR1, m_di_str1_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR2, m_di_str2_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR3, m_di_str3_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR4, m_di_str4_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR5, m_di_str5_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR6, m_di_str6_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR7, m_di_str7_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR0, m_do_str0_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR1, m_do_str1_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR2, m_do_str2_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR3, m_do_str3_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR4, m_do_str4_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR5, m_do_str5_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR6, m_do_str6_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR7, m_do_str7_ctrl);
	DDX_Text(pDX, IDC_EDIT_DI_STR0, m_di_str0);
	DDV_MaxChars(pDX, m_di_str0, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR1, m_di_str1);
	DDV_MaxChars(pDX, m_di_str1, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR2, m_di_str2);
	DDV_MaxChars(pDX, m_di_str2, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR3, m_di_str3);
	DDV_MaxChars(pDX, m_di_str3, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR4, m_di_str4);
	DDV_MaxChars(pDX, m_di_str4, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR5, m_di_str5);
	DDV_MaxChars(pDX, m_di_str5, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR6, m_di_str6);
	DDV_MaxChars(pDX, m_di_str6, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR7, m_di_str7);
	DDV_MaxChars(pDX, m_di_str7, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR0, m_do_str0);
	DDV_MaxChars(pDX, m_do_str0, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR1, m_do_str1);
	DDV_MaxChars(pDX, m_do_str1, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR2, m_do_str2);
	DDV_MaxChars(pDX, m_do_str2, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR3, m_do_str3);
	DDV_MaxChars(pDX, m_do_str3, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR4, m_do_str4);
	DDV_MaxChars(pDX, m_do_str4, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR5, m_do_str5);
	DDV_MaxChars(pDX, m_do_str5, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR6, m_do_str6);
	DDV_MaxChars(pDX, m_do_str6, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR7, m_do_str7);
	DDV_MaxChars(pDX, m_do_str7, 16);
	DDX_Text(pDX, IDC_EDIT_DDNS_HOSTNAME, m_ddns_hostname);
	DDV_MaxChars(pDX, m_ddns_hostname, 64);
	DDX_Text(pDX, IDC_EDIT_DDNS_ID, m_ddns_id);
	DDV_MaxChars(pDX, m_ddns_id, 32);
	DDX_Text(pDX, IDC_EDIT_DDNS_INTERVAL, m_ddns_interval);
	DDV_MinMaxInt(pDX, m_ddns_interval, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_DDNS_PORT_NUM, m_ddns_port);
	DDV_MinMaxInt(pDX, m_ddns_port, 0, 65535);
	DDX_Text(pDX, IDC_EDIT_DDNS_PWD, m_ddns_pwd);
	DDV_MaxChars(pDX, m_ddns_pwd, 16);
	DDX_Text(pDX, IDC_FW, m_fw_version);
	DDX_Text(pDX, IDC_EDIT_EA0, m_ea0);
	DDV_MaxChars(pDX, m_ea0, 2);
	DDX_Text(pDX, IDC_EDIT_EA1, m_ea1);
	DDV_MaxChars(pDX, m_ea1, 2);
	DDX_Text(pDX, IDC_EDIT_EA2, m_ea2);
	DDV_MaxChars(pDX, m_ea2, 2);
	DDX_Text(pDX, IDC_EDIT_EA3, m_ea3);
	DDV_MaxChars(pDX, m_ea3, 2);
	DDX_Text(pDX, IDC_EDIT_EA4, m_ea4);
	DDV_MaxChars(pDX, m_ea4, 2);
	DDX_Text(pDX, IDC_EDIT_EA5, m_ea5);
	DDV_MaxChars(pDX, m_ea5, 2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEzManagerLib_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CEzManagerLib_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, OnButtonSearch)
	ON_BN_CLICKED(IDC_RADIO_LOCAL, OnRadioLocal)
	ON_BN_CLICKED(IDC_RADIO_REMOTE, OnRadioRemote)
	ON_LBN_SELCHANGE(IDC_LIST_EZTCP, OnSelchangeListEztcp)
	ON_BN_CLICKED(IDC_BUTTON_STATUS, OnButtonStatus)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_PWD, OnButtonChangePwd)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_PWD, OnButtonDeletePwd)
	ON_BN_CLICKED(IDC_BUTTON_PWD_SET, OnButtonPwdSet)
	ON_BN_CLICKED(IDC_BUTTON_VERSION, OnButtonVersion)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_TCP, OnButtonCloseTcp)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzManagerLib_ExampleDlg message handlers

BOOL CEzManagerLib_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_remote_ip.SetAddress(ntohl(MK_IP(10,1,0,1)));
	this->m_remote_ip.EnableWindow(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEzManagerLib_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEzManagerLib_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEzManagerLib_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

static int qsort_compare(const void *env1, const void *env2)
{
	return memcmp(((struct lib_env *)env1)->net_env.mac_addr, ((struct lib_env *)env2)->net_env.mac_addr, 6);
}

void CEzManagerLib_ExampleDlg::OnButtonSearch() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	int nCnt, nErr, res, i = 0;
	CString str;
	_u32 ip;
	_u8* addr;
	in_addr in;

	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_Search(0, 0, lib_env_base, &nCnt, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		this->m_remote_ip.GetAddress(ip);
		
		if ( ip == 0 ) 
		{
			AfxMessageBox("IP ּҸ Էϼ.");
			return;
		}
		ip = htonl(ip);

		res = EzManager_Search(1, ip, lib_env_base, &nCnt, &nErr);
	}

	if ( nCnt > 1 )
	{
		qsort(lib_env_base, nCnt, sizeof(struct lib_env), qsort_compare);
	}

	if ( nCnt > 0 )
	{
		this->m_list_eztcp.ResetContent();

		if ( this->m_local_remote == 0 ) 
		{
			for ( i = 0 ; i < nCnt ; i++ )
			{
				addr = lib_env_base[i].net_env.mac_addr;
				str.Format("%02x:%02x:%02x:%02x:%02x:%02x",
					addr[0], addr[1], addr[2], addr[3], addr[4], addr[5]);
				m_list_eztcp.InsertString(i, str);
			}
		}
		else if ( this->m_local_remote == 1 ) 
		{
			for ( i = 0 ; i < nCnt ; i++ )
			{
				memcpy(&in.S_un.S_addr, &lib_env_base[i].net_env.socket_ip, 4);
				str.Format("%s", inet_ntoa(in));
				m_list_eztcp.InsertString(i, str);
			}
		}
	}
	else
	{
		str.Format("˻ ezTCP ϴ. [Error:%d]", nErr);
		this->m_list_eztcp.ResetContent();
		AfxMessageBox(str);
	}
}

void CEzManagerLib_ExampleDlg::OnRadioLocal() 
{
	// TODO: Add your control notification handler code here
	this->m_remote_ip.EnableWindow(FALSE);

	GetDlgItem(IDC_EDIT_EA0)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA1)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA2)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA3)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA4)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA5)->EnableWindow(TRUE);
}

void CEzManagerLib_ExampleDlg::OnRadioRemote() 
{
	// TODO: Add your control notification handler code here
	this->m_remote_ip.EnableWindow(TRUE);

	GetDlgItem(IDC_EDIT_EA0)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA1)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA2)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA3)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA4)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA5)->EnableWindow(FALSE);
}

void CEzManagerLib_ExampleDlg::OnSelchangeListEztcp() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();

	if ( idx >= 0 )
	{
		struct lib_env *lib_env = &this->lib_env_base[idx];

		this->m_remote_ip.SetAddress(ntohl(lib_env->net_env.socket_ip));

		this->m_ea0.Format("%02x", lib_env->net_env.mac_addr[0]);
		this->m_ea1.Format("%02x", lib_env->net_env.mac_addr[1]);
		this->m_ea2.Format("%02x", lib_env->net_env.mac_addr[2]);
		this->m_ea3.Format("%02x", lib_env->net_env.mac_addr[3]);
		this->m_ea4.Format("%02x", lib_env->net_env.mac_addr[4]);
		this->m_ea5.Format("%02x", lib_env->net_env.mac_addr[5]);

		//--------------------------------------------------------------------
		// pwd
		
		//--------------------------------------------------------------------

		//--------------------------------------------------------------------
		// Product information
		//
		int product_id;
		if ( lib_env->net_env.product_id_new > 0 )
			product_id = lib_env->net_env.product_id_new;
		else
			product_id = lib_env->net_env.product_id_old;

		int len;
		this->m_product = GetProductName(product_id, &len);
		//--------------------------------------------------------------------

		_u16 major, minor, rev;
		major = lib_env->net_env.major;
		minor = lib_env->net_env.minor>>8;
		rev   = lib_env->net_env.minor & 0x00ff;
		
		this->m_fw_version.Format("FW : %d.%d%c", major, minor, 0x61+rev);

		//-----------------------------------------------------------------
		// Network information
		//
		struct net_env		*p_net_env		= &lib_env->net_env;
		struct ip_trap_env	*ip_trap_env	= &lib_env->ip_trap_env;
		struct opt_env		*opt_env		= &lib_env->opt_env;

		m_local_ip.SetAddress(ntohl(p_net_env->local_ip));
		m_subnet.SetAddress(ntohl(p_net_env->net_mask));

		// IP Change Trap
		this->m_combo_ddns_ctrl.SetCurSel(opt_env->ddns);

		this->m_ddns_id.Format("%s", p_net_env->ddns_id);
		this->m_ddns_pwd.Format("%s", p_net_env->ddns_pwd);
		this->m_ddns_hostname.Format("%s", p_net_env->ddns_host_name);

		this->m_combo_style_ctrl.SetCurSel(ip_trap_env->level);

		this->m_ddns_port		= ip_trap_env->peer_port;
		this->m_ddns_interval	= ip_trap_env->interval;
		
		if ( ip_trap_env->peer_ip != 0 )
		{
			struct in_addr in;
			in.S_un.S_addr	= ip_trap_env->peer_ip;
			char* host_addr = inet_ntoa(in);
			this->m_ddns_hostname = host_addr;
		}
		//-----------------------------------------------------------------


		//------------------------------------------------------------------------------------
		// UART
		//
		struct uart_env		*p_uart_env		= lib_env->uart_env;
		//struct pseudo_uart_var_env	*p_uart_var_env = lib_env->pseudo_uart_var_env;

		for ( int port = 0 ; port < 4 ; port++ )
		{
			if ( p_uart_env[port].use_flag == 1 )
			{
				p_baud_ctrl[port]->EnableWindow(TRUE);
				p_mux_ctrl[port]->EnableWindow(TRUE);
				p_peer_ctrl[port]->EnableWindow(TRUE);

				p_baud[port]->Format("%d", p_uart_env[port].uart_dev_env.sio_baud);
				p_mux_ctrl[port]->SetCurSel(p_uart_env[port].uart_var_env.mux_type);

				*p_peer[port] = _T("");

				if ( p_uart_env[port].uart_var_env.peer_ip != 0 )
				{
					struct in_addr in;
					in.S_un.S_addr = p_uart_env[port].uart_var_env.peer_ip;
					char* host_addr = inet_ntoa(in);
					p_peer[port]->Format("%s", host_addr);
				}
				else
				{
					_u8 buf[65];
					memset(buf, 0, 65);
					memcpy(buf, p_uart_env[port].host_name, 64);
					p_peer[port]->Format("%s", buf);
				}

			}
			else
			{
				p_baud_ctrl[port]->EnableWindow(FALSE);
				p_mux_ctrl[port]->EnableWindow(FALSE);
				p_peer_ctrl[port]->EnableWindow(FALSE);
			}
		}
		//------------------------------------------------------------------------------------

		//------------------------------------------------------------------------------------
		// I/O information.
		//
		if ( product_id == OLD_PID_CIE_H10 
			|| product_id == PID_CIE_H10
			|| product_id == PID_CIE_M10 )
		{
			struct io_env	*p_io_env	= &lib_env_base[idx].io_env;
			struct opt_env	*p_opt_env	= &lib_env_base[idx].opt_env;

			if ( p_io_env->use_flag == 1 )
			{
				this->m_http	= p_opt_env->http;
				this->m_modbus	= p_io_env->io_var_env.modbus;
				this->m_macro	= p_io_env->io_var_env.macro;

				this->m_slave_id	= p_io_env->io_var_env.slave_id;
				this->m_input_addr  = p_io_env->io_var_env.input_addr;
				this->m_output_addr = p_io_env->io_var_env.output_addr;

				_u8 buf[33];

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[0], IO_SCRIPT_LEN);
				this->m_script_0.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[1], IO_SCRIPT_LEN);
				this->m_script_1.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[2], IO_SCRIPT_LEN);
				this->m_script_2.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[3], IO_SCRIPT_LEN);
				this->m_script_3.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[4], IO_SCRIPT_LEN);
				this->m_script_4.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[5], IO_SCRIPT_LEN);
				this->m_script_5.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[6], IO_SCRIPT_LEN);
				this->m_script_6.Format("%s", buf);

				memset(buf, 0, 33);
				memcpy(buf, p_io_env->script[7], IO_SCRIPT_LEN);
				this->m_script_7.Format("%s", buf);

				_u8 buf1[17];

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[0], IO_COMMENT_LEN);
				this->m_di_str0.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[1], IO_COMMENT_LEN);
				this->m_di_str1.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[2], IO_COMMENT_LEN);
				this->m_di_str2.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[3], IO_COMMENT_LEN);
				this->m_di_str3.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[4], IO_COMMENT_LEN);
				this->m_di_str4.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[5], IO_COMMENT_LEN);
				this->m_di_str5.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[6], IO_COMMENT_LEN);
				this->m_di_str6.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->di_comment[7], IO_COMMENT_LEN);
				this->m_di_str7.Format("%s", buf1);


				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[0], IO_COMMENT_LEN);
				this->m_do_str0.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[1], IO_COMMENT_LEN);
				this->m_do_str1.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[2], IO_COMMENT_LEN);
				this->m_do_str2.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[3], IO_COMMENT_LEN);
				this->m_do_str3.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[4], IO_COMMENT_LEN);
				this->m_do_str4.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[5], IO_COMMENT_LEN);
				this->m_do_str5.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[6], IO_COMMENT_LEN);
				this->m_do_str6.Format("%s", buf1);

				memset(buf1, 0, 17);
				memcpy(buf1, p_io_env->do_comment[7], IO_COMMENT_LEN);
				this->m_do_str7.Format("%s", buf1);

				m_script_0_ctrl.EnableWindow(TRUE);
				m_script_1_ctrl.EnableWindow(TRUE);
				m_script_2_ctrl.EnableWindow(TRUE);
				m_script_3_ctrl.EnableWindow(TRUE);
				m_script_4_ctrl.EnableWindow(TRUE);
				m_script_5_ctrl.EnableWindow(TRUE);
				m_script_6_ctrl.EnableWindow(TRUE);
				m_script_7_ctrl.EnableWindow(TRUE);

				m_slave_id_ctrl.EnableWindow(TRUE);
				m_output_addr_ctrl.EnableWindow(TRUE);
				m_input_addr_ctrl.EnableWindow(TRUE);

				m_modbus_ctrl.EnableWindow(TRUE);
				m_macro_ctrl.EnableWindow(TRUE);
				m_http_ctrl.EnableWindow(TRUE);

				m_di_str0_ctrl.EnableWindow(TRUE);
				m_di_str1_ctrl.EnableWindow(TRUE);
				m_di_str2_ctrl.EnableWindow(TRUE);
				m_di_str3_ctrl.EnableWindow(TRUE);
				m_di_str4_ctrl.EnableWindow(TRUE);
				m_di_str5_ctrl.EnableWindow(TRUE);
				m_di_str6_ctrl.EnableWindow(TRUE);
				m_di_str7_ctrl.EnableWindow(TRUE);

				m_do_str0_ctrl.EnableWindow(TRUE);
				m_do_str1_ctrl.EnableWindow(TRUE);
				m_do_str2_ctrl.EnableWindow(TRUE);
				m_do_str3_ctrl.EnableWindow(TRUE);
				m_do_str4_ctrl.EnableWindow(TRUE);
				m_do_str5_ctrl.EnableWindow(TRUE);
				m_do_str6_ctrl.EnableWindow(TRUE);
				m_do_str7_ctrl.EnableWindow(TRUE);
			}
		}
		else
		{
			m_script_0_ctrl.EnableWindow(FALSE);
			m_script_1_ctrl.EnableWindow(FALSE);
			m_script_2_ctrl.EnableWindow(FALSE);
			m_script_3_ctrl.EnableWindow(FALSE);
			m_script_4_ctrl.EnableWindow(FALSE);
			m_script_5_ctrl.EnableWindow(FALSE);
			m_script_6_ctrl.EnableWindow(FALSE);
			m_script_7_ctrl.EnableWindow(FALSE);

			m_slave_id_ctrl.EnableWindow(FALSE);
			m_output_addr_ctrl.EnableWindow(FALSE);
			m_input_addr_ctrl.EnableWindow(FALSE);

			m_modbus_ctrl.EnableWindow(FALSE);
			m_macro_ctrl.EnableWindow(FALSE);
			m_http_ctrl.EnableWindow(FALSE);

			m_di_str0_ctrl.EnableWindow(FALSE);
			m_di_str1_ctrl.EnableWindow(FALSE);
			m_di_str2_ctrl.EnableWindow(FALSE);
			m_di_str3_ctrl.EnableWindow(FALSE);
			m_di_str4_ctrl.EnableWindow(FALSE);
			m_di_str5_ctrl.EnableWindow(FALSE);
			m_di_str6_ctrl.EnableWindow(FALSE);
			m_di_str7_ctrl.EnableWindow(FALSE);

			m_do_str0_ctrl.EnableWindow(FALSE);
			m_do_str1_ctrl.EnableWindow(FALSE);
			m_do_str2_ctrl.EnableWindow(FALSE);
			m_do_str3_ctrl.EnableWindow(FALSE);
			m_do_str4_ctrl.EnableWindow(FALSE);
			m_do_str5_ctrl.EnableWindow(FALSE);
			m_do_str6_ctrl.EnableWindow(FALSE);
			m_do_str7_ctrl.EnableWindow(FALSE);
		}
		//------------------------------------------------------------------------------------

		UpdateData(FALSE);
	}
}

static char* tcp_state[] =
{
	"CLOSED", "LISTEN", "SYN_SENT", "SYN_RCVD", "ESTABLISHED", "FIN_WAIT1",
	"FIN_WAIT2", "CLOSE_WAIT", "CLOSING", "LAST_ACK", "TIME_WAIT", "END"
};

void CEzManagerLib_ExampleDlg::OnButtonStatus() 
{
	// TODO: Add your control notification handler code here

	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	_u8 stat_buf[1500];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct lib_env* lib_env = &this->lib_env_base[idx];
	
	m_status = _T("");


	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_Status(0, lib_env, stat_buf, 1500, this->tcp_status_env, &this->m_tcp_count, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		res = EzManager_Status(1, lib_env, stat_buf, 1500, this->tcp_status_env, &this->m_tcp_count, &nErr);
	}

	this->m_tcp_connection.ResetContent();

	if ( res == 1 )
	{
		this->m_status.Format("%s", stat_buf);

		if ( this->m_tcp_count > 0 )
		{
			for ( int i = 0 ; i < this->m_tcp_count ; i++ )
			{
				CString str;
				struct tcp_status_env *tcp_status_env = &this->tcp_status_env[i];
				char * ptr = tcp_state[tcp_status_env->stat];
				if ( tcp_status_env->stat == 0
				  || tcp_status_env->stat == 5
				  || tcp_status_env->stat == 6 
				  || tcp_status_env->stat == 7
				  || tcp_status_env->stat == 8 
				  || tcp_status_env->stat == 10
				  || tcp_status_env->stat == 11 )
				{
					str.Format("[%s] %s",tcp_status_env->name, ptr);
				}
				else if ( tcp_status_env->stat == 1 )
				{
					str.Format("[%s] %s:%d", tcp_status_env->name, ptr, tcp_status_env->local_port);
				}
				else if ( tcp_status_env->stat == 2 
					   || tcp_status_env->stat == 3
					   || tcp_status_env->stat == 4 
					   || tcp_status_env->stat == 9 )
				{
					struct in_addr in;
					in.S_un.S_addr		= tcp_status_env->peer_ip;
					str.Format("[%s] %s %s:%d", tcp_status_env->name, ptr, inet_ntoa(in), tcp_status_env->peer_port);
				}
				this->m_tcp_connection.AddString(str);
			}
			this->m_tcp_connection.SetCurSel(0);
		}
	}
	else
	{
		switch(nErr)
		{
		case EZTCP_ERR_RES:
			AfxMessageBox("No response from selected ezTCP.");
			break;
		case EZTCP_ERR_PWD:
			AfxMessageBox("Password mismatch error occured.");
			break;
		}
	}
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonWrite() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	_u8 pwd_buf[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct lib_env lib_env = this->lib_env_base[idx];

	if ( !UpdateData(TRUE) ) return;
	
	//-----------------------------------------------------------------
	// Network information
	//
	struct net_env		*p_net_env		= &lib_env.net_env;
	struct opt_env		*opt_env		= &lib_env.opt_env;
	struct ip_trap_env	*ip_trap_env	= &lib_env.ip_trap_env;

	m_local_ip.GetAddress(p_net_env->local_ip);
	m_subnet.GetAddress(p_net_env->net_mask);

	p_net_env->local_ip = htonl(p_net_env->local_ip);
	p_net_env->net_mask = htonl(p_net_env->net_mask);

	// IP Change Trap
	opt_env->ddns = this->m_combo_ddns_ctrl.GetCurSel();

	if ( !this->m_ddns_id.IsEmpty() )
	{
		int copy_len;
		copy_len = this->m_ddns_id.GetLength() >= 32 ? 32 : this->m_ddns_id.GetLength();
		memcpy(p_net_env->ddns_id, this->m_ddns_id, copy_len);
	}
	if ( !this->m_ddns_pwd.IsEmpty() )
	{
		int copy_len;
		copy_len = this->m_ddns_pwd.GetLength() >= 16 ? 16 : this->m_ddns_pwd.GetLength();
		memcpy(p_net_env->ddns_pwd, this->m_ddns_pwd, copy_len);
	}
	if ( !this->m_ddns_hostname.IsEmpty() )
	{
		int copy_len;
		copy_len = this->m_ddns_hostname.GetLength() >= 60 ? 60 : this->m_ddns_hostname.GetLength();
		memcpy(p_net_env->ddns_host_name, this->m_ddns_hostname, copy_len);

		unsigned long int res = inet_addr(this->m_ddns_hostname);
		if ( res == INADDR_NONE )
		{
			if ( this->m_ddns_hostname.CompareNoCase("255.255.255.255") == 0 ) 
			{
				ip_trap_env->peer_ip = res;
			}
			else
			{
				ip_trap_env->peer_ip = 0;
			}
		}
		else
		{
			ip_trap_env->peer_ip = res;
		}
	}
	else
	{
		ip_trap_env->peer_ip = 0;
	}
	
	ip_trap_env->level		= this->m_combo_style_ctrl.GetCurSel();
	ip_trap_env->peer_port	= this->m_ddns_port;
	ip_trap_env->interval	= this->m_ddns_interval;
	//-----------------------------------------------------------------

	//------------------------------------------------------------------------------------
	// UART
	//
	struct uart_env		*p_uart_env		= lib_env.uart_env;

	for ( int port = 0 ; port < 4 ; port++ )
	{
		if ( p_uart_env[port].use_flag == 1 )
		{
			CString b_temp = *p_baud[port];
			CString a_temp = *p_peer[port];

			p_uart_env[port].uart_dev_env.sio_baud = strtol(b_temp, 0, 10);
			p_uart_env[port].uart_var_env.mux_type = p_mux_ctrl[port]->GetCurSel();

			if ( a_temp.GetLength() != 0 )
			{
				unsigned long int res = inet_addr(a_temp);

				if ( res == INADDR_NONE )
				{
					if ( a_temp.CompareNoCase("255.255.255.255") == 0 )
					{
						p_uart_env[port].uart_var_env.peer_ip = res;
					}
					else
					{
						p_uart_env[port].uart_var_env.peer_ip = 0;
						//sprintf((char*)p_uart_var_env[port].host_name, "%s", a_temp);
						memset(p_uart_env[port].host_name, 0, 64);
						memcpy(p_uart_env[port].host_name, a_temp, a_temp.GetLength()>64?64:a_temp.GetLength());
					}
				}
				else
				{
					p_uart_env[port].uart_var_env.peer_ip = res;
				}
			}
			else
			{
				p_uart_env[port].uart_var_env.peer_ip = 0;
				memset(p_uart_env[port].host_name, 0x00, 64);
			}
		}
	}

	//------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------
	// I/O information.
	//
	int product_id;
	if ( lib_env.net_env.product_id_new > 0 )
		product_id = lib_env.net_env.product_id_new;
	else
		product_id = lib_env.net_env.product_id_old;

	if ( product_id == OLD_PID_CIE_H10 
			|| product_id == PID_CIE_H10
			|| product_id == PID_CIE_M10 )
	{
		struct io_env	*p_io_env	= &lib_env.io_env;
		struct opt_env	*p_opt_env	= &lib_env.opt_env;

		if ( p_io_env->use_flag == 1 )
		{
			p_opt_env->http				= this->m_http;
			p_io_env->io_var_env.modbus = this->m_modbus;
			p_io_env->io_var_env.macro  = this->m_macro;

			p_io_env->io_var_env.slave_id		= this->m_slave_id;
			p_io_env->io_var_env.input_addr		= this->m_input_addr;
			p_io_env->io_var_env.output_addr	= this->m_output_addr;

			
			memset(p_io_env->script[0], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[0], this->m_script_0, this->m_script_0.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_0.GetLength());

			memset(p_io_env->script[1], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[1], this->m_script_1, this->m_script_1.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_1.GetLength());

			memset(p_io_env->script[2], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[2], this->m_script_2, this->m_script_2.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_2.GetLength());

			memset(p_io_env->script[3], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[3], this->m_script_3, this->m_script_3.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_3.GetLength());

			memset(p_io_env->script[4], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[4], this->m_script_4, this->m_script_4.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_4.GetLength());

			memset(p_io_env->script[5], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[5], this->m_script_5, this->m_script_5.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_5.GetLength());

			memset(p_io_env->script[6], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[6], this->m_script_6, this->m_script_6.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_6.GetLength());

			memset(p_io_env->script[7], 0, IO_SCRIPT_LEN);
			memcpy(p_io_env->script[7], this->m_script_7, this->m_script_7.GetLength()>IO_SCRIPT_LEN?IO_SCRIPT_LEN:this->m_script_7.GetLength());

			if ( p_io_env->io_var_env.output_addr != 0 )
			{
				if ( p_io_env->io_var_env.input_addr + 8 > p_io_env->io_var_env.output_addr 
					&& p_io_env->io_var_env.input_addr - 8 < p_io_env->io_var_env.output_addr)
				{
					CString msg;
					msg = "The difference between input and output port address should be over 8.";
					AfxMessageBox(msg);
					return;
				}
			}
			
			memset(p_io_env->di_comment[0], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[0], this->m_di_str0, this->m_di_str0.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str0.GetLength());

			memset(p_io_env->di_comment[1], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[1], this->m_di_str1, this->m_di_str1.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str1.GetLength());

			memset(p_io_env->di_comment[2], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[2], this->m_di_str2, this->m_di_str2.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str2.GetLength());

			memset(p_io_env->di_comment[3], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[3], this->m_di_str3, this->m_di_str3.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str3.GetLength());

			memset(p_io_env->di_comment[4], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[4], this->m_di_str4, this->m_di_str4.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str4.GetLength());

			memset(p_io_env->di_comment[5], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[5], this->m_di_str5, this->m_di_str5.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str5.GetLength());

			memset(p_io_env->di_comment[6], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[6], this->m_di_str6, this->m_di_str6.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str6.GetLength());

			memset(p_io_env->di_comment[7], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->di_comment[7], this->m_di_str7, this->m_di_str7.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_di_str7.GetLength());


			memset(p_io_env->do_comment[0], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[0], this->m_do_str0, this->m_do_str0.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str0.GetLength());

			memset(p_io_env->do_comment[1], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[1], this->m_do_str1, this->m_do_str1.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str1.GetLength());

			memset(p_io_env->do_comment[2], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[2], this->m_do_str2, this->m_do_str2.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str2.GetLength());

			memset(p_io_env->do_comment[3], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[3], this->m_do_str3, this->m_do_str3.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str3.GetLength());

			memset(p_io_env->do_comment[4], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[4], this->m_do_str4, this->m_do_str4.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str4.GetLength());

			memset(p_io_env->do_comment[5], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[5], this->m_do_str5, this->m_do_str5.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str5.GetLength());

			memset(p_io_env->do_comment[6], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[6], this->m_do_str6, this->m_do_str6.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str6.GetLength());

			memset(p_io_env->do_comment[7], 0, IO_COMMENT_LEN);
			memcpy(p_io_env->do_comment[7], this->m_do_str7, this->m_do_str7.GetLength()>IO_COMMENT_LEN?IO_COMMENT_LEN:this->m_do_str7.GetLength());

		}
	}
	//-------------------------------------------------------------------

	//-------------------------------------------------------------------
	// password
	memset(pwd_buf, 0x00, PASSWD_SIZE);

	if ( this->m_cur_pwd.GetLength() != 0 )
	{
		memcpy(pwd_buf, this->m_cur_pwd, this->m_cur_pwd.GetLength());
	}
	//-------------------------------------------------------------------

	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_Write(0, &lib_env, pwd_buf, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		res = EzManager_Write(1, &lib_env, pwd_buf, &nErr);
	}

	if ( res == 1 )
	{
		AfxMessageBox("Write success...");
		memcpy(&this->lib_env_base[idx], &lib_env, sizeof(struct lib_env));
	}
	else
	{
		this->print_error_message(nErr);
	}
}

void CEzManagerLib_ExampleDlg::OnButtonChangePwd() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	_u8 cur_pwd[PASSWD_SIZE];
	_u8 new_pwd[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct lib_env lib_env = this->lib_env_base[idx];

	UpdateData(TRUE);

	//-------------------------------------------------------------------
	// password
	if ( this->m_cur_pwd.GetLength() == 0 )
	{
		AfxMessageBox("Enter the password.");
		return;
	}

	if ( this->m_new_pwd.GetLength() == 0 )
	{
		AfxMessageBox("Enter the password.");
		return;
	}

	if ( this->m_cur_pwd.GetLength() > 8 )
	{
		AfxMessageBox("Maximum password length is 8.");
		return;
	}

	if ( this->m_new_pwd.GetLength() > 8 )
	{
		AfxMessageBox("Maximum password length is 8.");
		return;
	}

	memset(cur_pwd, 0x00, PASSWD_SIZE);
	memcpy(cur_pwd, this->m_cur_pwd, this->m_cur_pwd.GetLength());

	memset(new_pwd, 0x00, PASSWD_SIZE);
	memcpy(new_pwd, this->m_new_pwd, this->m_new_pwd.GetLength());
	//-------------------------------------------------------------------

	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_ChangePwd(0, &lib_env, cur_pwd, new_pwd, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		res = EzManager_ChangePwd(1, &lib_env, cur_pwd, new_pwd, &nErr);
	}

	if ( res == 1 )
	{
		AfxMessageBox("Password write success...");
		memcpy(&this->lib_env_base[idx], &lib_env, sizeof(struct lib_env));
	}
	else
	{
		this->print_error_message(nErr);
	}

	this->m_cur_pwd = _T("");
	this->m_new_pwd = _T("");
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonDeletePwd() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	_u8 cur_pwd[PASSWD_SIZE];
	_u8 new_pwd[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct lib_env lib_env = this->lib_env_base[idx];

	UpdateData(TRUE);

	//-------------------------------------------------------------------
	// password
	memset(cur_pwd, 0x00, PASSWD_SIZE);
	if ( this->m_cur_pwd.GetLength() > 0 )
		memcpy(cur_pwd, this->m_cur_pwd, this->m_cur_pwd.GetLength());

	memset(new_pwd, 0x00, PASSWD_SIZE);	
	//-------------------------------------------------------------------

	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_ChangePwd(0, &lib_env, cur_pwd, new_pwd, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		res = EzManager_ChangePwd(1, &lib_env, cur_pwd, new_pwd, &nErr);
	}

	if ( res == 1 )
	{
		AfxMessageBox("Password write success...");
		memcpy(&this->lib_env_base[idx], &lib_env, sizeof(struct lib_env));
	}
	else
	{
		this->print_error_message(nErr);
	}

	this->m_cur_pwd = _T("");
	this->m_new_pwd = _T("");
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonPwdSet() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	_u8 new_pwd[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct lib_env lib_env = this->lib_env_base[idx];

	UpdateData(TRUE);

	//-------------------------------------------------------------------
	// password
	if ( this->m_new_pwd.GetLength() == 0 )
	{
		AfxMessageBox("Enter the password.");
		return;
	}

	if ( this->m_new_pwd.GetLength() > 8 )
	{
		AfxMessageBox("Maximum password length is 8.");
		return;
	}
	memset(new_pwd, 0x00, PASSWD_SIZE);
	memcpy(new_pwd, this->m_new_pwd, this->m_new_pwd.GetLength());
	//-------------------------------------------------------------------

	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_ChangePwd(0, &lib_env, NULL, new_pwd, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		res = EzManager_ChangePwd(1, &lib_env, NULL, new_pwd, &nErr);
	}

	if ( res == 1 )
	{
		AfxMessageBox("Password write success...");
		memcpy(&this->lib_env_base[idx], &lib_env, sizeof(struct lib_env));
	}
	else
	{
		this->print_error_message(nErr);
	}

	this->m_cur_pwd = _T("");
	this->m_new_pwd = _T("");
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonVersion() 
{
	// TODO: Add your control notification handler code here
	/*char buf[128];
	
	int res = GetLibVerEzManager((char*)buf, 128);

	if ( res )
		AfxMessageBox(buf);*/

	char* buf;
	int len;

	buf = GetLibVer(&len);

	AfxMessageBox(buf);
}

void CEzManagerLib_ExampleDlg::OnButtonCloseTcp() 
{
	// TODO: Add your control notification handler code here
	_u8 pwd_buf[PASSWD_SIZE];
	int res, nErr;
	int idx = this->m_tcp_connection.GetCurSel();
	int idx2 = this->m_list_eztcp.GetCurSel();
	if ( idx < 0 ) return;

	if ( idx2 < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct lib_env lib_env = this->lib_env_base[idx2];
	
	struct tcp_status_env tcp_status_env = this->tcp_status_env[idx];

	if ( tcp_status_env.stat != 4 )
	{
		AfxMessageBox("It's status is not ESTABLISHED");
		return;
	}

	if ( !UpdateData(TRUE) ) return;

	//-------------------------------------------------------------------
	// password
	memset(pwd_buf, 0x00, PASSWD_SIZE);

	if ( this->m_cur_pwd.GetLength() != 0 )
	{
		memcpy(pwd_buf, this->m_cur_pwd, this->m_cur_pwd.GetLength());
	}
	//-------------------------------------------------------------------

	/*
	int EzManager_CloseTCP(int mode,
					   struct lib_env* lib_env,
					   struct tcp_status_env* tcp_status_env,
					   _u8* cur_pwd,
					   int* nErrNum);
	*/

	if ( this->m_local_remote == 0 ) // local
	{
		res = EzManager_CloseTCP(0, &lib_env, &tcp_status_env, pwd_buf, &nErr);
	}
	else if ( this->m_local_remote == 1 ) // remote
	{
		res = EzManager_CloseTCP(1, &lib_env, &tcp_status_env, pwd_buf, &nErr);
	}

	if ( res == 1 )
	{
		AfxMessageBox("success...");
	}
	else
	{
		this->print_error_message(nErr);
	}
}


void CEzManagerLib_ExampleDlg::OnButtonRead() 
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData(TRUE) ) return;

	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	_u8 mac_addr[6];
	_u32 ip;
	struct lib_env lib_env;

	lib_env = this->lib_env_base[0];

	mac_addr[0] = (_u8)strtol(this->m_ea0, 0 , 16);
	mac_addr[1] = (_u8)strtol(this->m_ea1, 0 , 16);
	mac_addr[2] = (_u8)strtol(this->m_ea2, 0 , 16);
	mac_addr[3] = (_u8)strtol(this->m_ea3, 0 , 16);
	mac_addr[4] = (_u8)strtol(this->m_ea4, 0 , 16);
	mac_addr[5] = (_u8)strtol(this->m_ea5, 0 , 16);
	
	this->m_remote_ip.GetAddress(ip);
	ip = htonl(ip);
	
	res = EzManager_Read(this->m_local_remote,
						 mac_addr,
						 ip,
						 &lib_env,
						 &nErr);

	if ( res == 1 ) // read success
	{
		memcpy(&this->lib_env_base[0], &lib_env, sizeof(struct lib_env));

		this->m_list_eztcp.ResetContent();

		if ( this->m_local_remote == 0 ) 
		{
			CString str;
			str.Format("%02x:%02x:%02x:%02x:%02x:%02x",
				this->lib_env_base[0].net_env.mac_addr[0], 
				this->lib_env_base[0].net_env.mac_addr[1], 
				this->lib_env_base[0].net_env.mac_addr[2], 
				this->lib_env_base[0].net_env.mac_addr[3], 
				this->lib_env_base[0].net_env.mac_addr[4], 
				this->lib_env_base[0].net_env.mac_addr[5]);
			m_list_eztcp.InsertString(0, str);
		}
		else if ( this->m_local_remote == 1 ) 
		{
			CString str;
			in_addr in;
			memcpy(&in.S_un.S_addr, &lib_env_base[0].net_env.socket_ip, 4);
			str.Format("%s", inet_ntoa(in));
			m_list_eztcp.InsertString(0, str);
		}

		this->m_list_eztcp.SetCurSel(0);
		OnSelchangeListEztcp();
	}
	else // read fail
	{
		this->print_error_message(nErr);
	}
}

void CEzManagerLib_ExampleDlg::print_error_message(int code)
{
	CString msg;
	switch(code)
	{
	case EZTCP_ERR_PWD:
		AfxMessageBox("Password mismatch error occured.");
		break;
	case EZTCP_ERR_RES:
		AfxMessageBox("No response from selected ezTCP.");
		break;
	case EZTCP_ERR_LOCAL_IP:
		AfxMessageBox("Local IP Address Error");
		break;
	case EZTCP_ERR_IO_SCRIPT:
		AfxMessageBox("Macro Syntax Error");
		break;
	case EZTCP_ERR_IO_ADDR:
		AfxMessageBox("I/O Port Address Error");
		break;
	case EZTCP_ERR_LOCAL_PORT_100:
		AfxMessageBox("Local Port Number Error");
		break;
	case EZTCP_ERR_LOCAL_PORT_101:
		AfxMessageBox("Port Number 23 is not available");
		break;
	case EZTCP_ERR_LOCAL_PORT_102:
		AfxMessageBox("Local and Modbus/TCP Port numbers are duplicated.");
		break;
	case EZTCP_ERR_LOCAL_PORT_103:
		AfxMessageBox("The port number 80 is not available for Local Port.");
		break;
	case EZTCP_ERR_LOCAL_PORT_104:
		AfxMessageBox("The port number 50005 is not available for Local Port.");
		break;
	case EZTCP_ERR_LOCAL_PORT_105:
		AfxMessageBox("The port number 50006 is not available for Local Port.");
		break;
	case EZTCP_ERR_PRODUCT_MISMATCH:
		AfxMessageBox("Product ID Mismatch");
		break;
	case EZTCP_ERR_UNKNOWN:
		AfxMessageBox("Unknown Error");
		break;
	case EZTCP_ERR_NO_INFO:
		AfxMessageBox("There is no available information to write.");
		break;
	default:
		msg.Format("Invalid Error Code [%d]", code);
		AfxMessageBox(msg);
		break;
	}
}
